VCMD0028040000000000COMPONENT          
Node "rSimResource"
{
Name "AGV Task Sequencer (modified)"
Id 1
NodeClass 
{
Id 1
Feature "rGeoFeature"
{
Name "Cone"

Visible 1

Uri "cone"
OnDemandLoad 0
UseBackfaces 0
MaterialInheritance "Disabled"
}
Feature "rGeoFeature"
{
Name "Geometry"

Visible 1

Uri "geometry"
OnDemandLoad 0
UseBackfaces 0
MaterialInheritance "Disabled"
}
VCID "a2d0ce2e-2713-4bfa-aa54-3dc6b3eaa24a"
}
Functionality "rPythonScript"
{
Id 1
Name "PythonScript"
Script "from vcScript import *\n\napp = getApplication()
\ncomp = getComponent()
\nthis_script = comp.findBehaviour( 'PythonScript' )
\n
\ndef OnSignal(signal):
\n  global pickupsignals, tasks
\n  #print signal.Name, signal.Value
\n  if signal.Value and signal in pickupsignals:
\n    c = signal.Value.Parent.Component
\n    task = [c, c.AGV_ID] #comp + agv id
\n    tasks.append( task )
\n\ndef OnRun():
\n  global pickupsignals, tasks, do_this_task
\n  
\n  seq = []
\n  note = comp.findBehaviour( 'PickSequences' )
\n  data  = note.Note.split(\"\\r\\n\")
\n  seq = [x.split(\",\") for x in data]
\n  
\n  waiting_AGVS = []
\n  
\n  tasks = []
\n  agv_list = [x for x in app.Components if x.getProperty('__type') and x.__type in ['train','agv'] ]
\n  wait_locations = [x for x in app.Components if x.getProperty('__type') and x.__type in ['waitlocation'] ]
\n  pickupsignals = registerPickupSignal()
\n
\n  while True:
\n    delay(1.0)
\n    picks = []
\n    drops = []
\n    
\n    for list in seq:
\n      for p in list:
\n        found_agv = None
\n        for task in tasks:
\n          at_component, neededagv = task
\n          if at_component.Name == p:
\n            for agv in agv_list:
\n              if agv.AgvID in neededagv.split(\",\") and agv.Busy == False and (found_agv == None or found_agv == agv):
\n                found_agv = agv              
\n                cc = 0
\n                for ccc in str(at_component.AGV_PickCount).split(\",\"):
\n                  cc=cc + int(ccc)
\n                task1 = [agv,\"Pick,\"+at_component.Name+\",\"+str(at_component.AGV_Wagon)+\",\"+str(cc)]
\n                picks.append(task1)
\n                
\n                droplist = at_component.AGV_DropLocationName.split(\",\")
\n                c = len(droplist)
\n                for d in range(c):
\n                  task2 = [agv,\"Drop,\"+at_component.AGV_DropLocationName.split(\",\")[d]+\",\"+str(at_component.AGV_Wagon)+\",\"+str(at_component.AGV_PickCount).split(\",\")[d]]
\n                  drops.append(task2)
\n                
\n                tasks.remove( task )
\n    
\n    # modified start
\n    if comp.PickThenDropSingle:
\n      dropIndex = 0
\n      for p in picks:
\n        s = p[0].findBehaviour(\"Task\")
\n        s.signal(p[1])
\n        delay(0)
\n        itemsToDrop = int(p[1].split(',')[-1])
\n        itemCount = 0
\n        while itemCount < itemsToDrop:
\n          d = drops[dropIndex]
\n          s = d[0].findBehaviour(\"Task\")
\n          s.signal(d[1])
\n          delay(0)
\n          itemCount += int(d[1].split(',')[-1])
\n          dropIndex += 1
\n    else:
\n    # modified end
\n      for p in picks:  
\n        s = p[0].findBehaviour(\"Task\")
\n        s.signal(p[1])
\n        delay(0)
\n      for d in drops:  
\n        s = d[0].findBehaviour(\"Task\")
\n        s.signal(d[1])
\n        delay(0)
\n    
\n    for task in tasks:
\n      at_component, neededagv = task
\n      found = False
\n      for agv in agv_list:
\n        if agv.AgvID in neededagv.split(\",\") and agv.Busy == False and found == False:
\n          s = agv.findBehaviour(\"Task\")
\n          cc = 0
\n          for ccc in str(at_component.AGV_PickCount).split(\",\"):
\n            cc=cc + int(ccc)
\n          task1 = \"Pick,\"+at_component.Name+\",\"+str(at_component.AGV_Wagon)+\",\"+str(cc)
\n          s.signal(task1)
\n          delay(0)
\n          droplist = at_component.AGV_DropLocationName.split(\",\")
\n          c = len(droplist)
\n          for d in range(c):
\n            task2 = \"Drop,\"+at_component.AGV_DropLocationName.split(\",\")[d]+\",\"+str(at_component.AGV_Wagon)+\",\"+str(at_component.AGV_PickCount).split(\",\")[d]
\n            s.signal(task2)
\n            delay(0)
\n            
\n          tasks.remove( task )
\n          found = True
\n    for agv in agv_list:
\n      if agv.Busy == False and agv not in waiting_AGVS:
\n        for w in wait_locations:
\n          if w.AgvID == agv.AgvID:
\n            task1 = \"Move,\"+w.Name+\",0.1\"
\n            s = agv.findBehaviour(\"Task\")
\n            s.signal(task1)
\n            delay(0.1)
\n            agv.Busy = False
\n            waiting_AGVS.append(agv) ##not to call train to waiting location many times
\n      if agv.Busy == True:
\n        if agv in waiting_AGVS:
\n          waiting_AGVS.remove(agv)
\n
\n#def register_trigger(arg):
\n#  trigger.signal(True)
\n
\ndef registerPickupSignal():
\n  signals = []
\n  for c in app.Components:
\n    if c.getProperty('AGV_DropLocationName'): #only pickup loocations!
\n      if c.UseLocalCall == False:
\n        s = c.findBehaviour( 'SensorSignal' )
\n        signals.append( s )
\n        connections = s.Connections
\n        if this_script not in connections:
\n          connections.append( this_script )
\n          s.Connections = connections
\n  return signals"
CompatibilityMode 1
}
Functionality "rNote"
{
Id 2
Name "PickSequences"
Note "A,B,C"
}
VCID a2d0ce2e-2713-4bfa-aa54-3dc6b3eaa24a
Revision 5
Location 1 0 0 0 0 1 0 0 0 0 1 0 0 0 0 1 
ActiveSimulationLevel detailed
BOM  0

BOMname  "AGV Task Sequencer (modified)"

BOMdescription  "AGV Task Sequencer"

Category  "AGV (beta)"

VariableSpace ""
{
  Variable "rTVariable<rBool>"
  {
    Name "Visible"
    Value 1
    Group -1130
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      MANAGED
    }
  }
  Variable "rTVariable<rBool>"
  {
    Name "PickThenDropSingle"
    Value 1
    Group 10
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      ON_EDIT_REBUILD
      TRANSLATE_USING_GETTEXT
    }
  }
}
}
